#include "Character.h"
#include "lib/errorcodes.h"

//Character::Character ()

// Methods using the CharacterName
AlString Character::getCharacterName()
{
	return CharacterName;
}

int Character::setCharacterName(AlString newName)
{
	if (newName.getLength() <= 15)
	{
		CharacterName = newName;
		return NO_ERROR;
	}
	else
		return CHARACTER_NAME_TOO_LONG;
}

// Methods for the Experience
unsigned long long Character::getExperience()
{
	return Experience;
}

int Character::gainExperience(unsigned short points)
{
	// Anti-cheating: gaining experience is limited by doubling 
	// the experience plus a tolorance of 20 points.
	if (points < (Experience + 20))
	{
		// Overflow-protection: Checks the "unsigned long long Experience"
		if ((Experience + points) >= Experience)
		{
			Experience += points;
			return NO_ERROR;
		}
		else
			return EXPERIENCE_OVERFLOW;
	}
	else
		return EXPERIENCE_CHEATING;
}

int Character::looseExperience(unsigned short malus)
{
	// maximum Malus is 10%
	if (malus < 100)
	{
		double malus_factor;

		malus_factor = (double) (1000 - malus) / 1000; 
		Experience = (unsigned long long) (Experience * malus_factor);
		return NO_ERROR;
	}
	else
		return MALUS_TOO_LARGE; 
}
